=== debian/changelog ===
eternallands (1.9.6.1-0ubuntu1) bionic; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 11:18:07 +0000
