=== pkgfiles/debs/data/debian/changelog ===
eternallands-data (1.9.6.1-0ubuntu1) bionic; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 11:47:25 +0000
