=== pkgfiles/debs/music/debian/changelog ===
eternallands-music (1.9.5.9-0ubuntu1) xenial; urgency=low

  * 1.9.5p9 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Fri, 09 Apr 2021 15:25:07 +0100
