=== pkgfiles/debs/sound/debian/changelog ===
eternallands-sound (1.9.6.1-0ubuntu1) xenial; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 12:43:10 +0000
