=== debian/control ===
Source: eternallands
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9), libsdl2-dev, libsdl2-net-dev, libsdl2-image-dev, libsdl2-ttf-dev, libxml2-dev, libogg-dev, libvorbis-dev, libopenal-dev, libcal3d12-dev, libxrandr-dev, zlib1g-dev, libpng12-dev|libpng-dev, libssl-dev, cmake
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, eternallands-data (>=1.9.6), zenity
Recommends: eternallands-sound (>=1.9.5)
Suggests: eternallands-music (>=1.9.5)
Description: client package for Eternal Lands, a free MMORPG 
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal.
