=== pkgfiles/debs/data/debian/control ===
Source: eternallands-data
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands-data
Architecture: all
Depends: ${misc:Depends}, wget (>>1), unzip (>>2), findutils (>>4), eternallands (>=1.9.6)
Recommends: eternallands-sound (>=1.9.6)
Suggests: eternallands-music (>=1.9.5)
Description: data package for Eternal Lands, a free MMORPG
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal. 
 .
 NOTE: This package will download and install the Eternal Lands data
 archive from twinmoons.org.uk.  This file is the same as the official
 release but hosted to ensure the package continues to work if the
 archive is moved or modified.
