=== pkgfiles/debs/music/debian/control ===
Source: eternallands-music
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands-music
Architecture: all
Depends: wget (>>1), unzip (>>2), findutils (>>4), eternallands (>=1.9.5), eternallands-data (>=1.9.5)
Description: the music package for Eternal Lands, a free MMORPG
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal. 
 .
 WARNING: Installing this package causes the Eternal Lands music to be
 downloaded from twinmoons.org.uk and installed.
