=== debian/watch ===
version=3

# Source is at https://github.com/raduprv/Eternal-Lands
