=== pkgfiles/debs/data/debian/watch ===
version=3

# There is no source to watch.
# This package purely downloads and installs game binary data.
